/*  Feb,Mar,Oct 1999 JTdidit jt@epix.net */
lev='1.X.6'
level = lev '23 Oct 1999'
/* imaghtml.cmd - JT command to build html file to show all jpg and gif */
/* images in a directory.   */

call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
call SysLoadFuncs

Say 'imaghtml.cmd version' level 'Usage is imaghtml [outfile] [cols]'
Say 'Builds an HTML file to show all the jpg and gif files in a directory'
Say 'Default outfile is "images.htm"'
Say 'Layout is in "cols" columns (default is 5)'
Say 'This version shows the image size and file size for each file'
Say 'and includes them in the URL along with an ALT=[filename] tag'
Say 'useful for pasting from the html output file into the document'
Say 'you are working on.'
say ''

parse arg outfile cols .
if outfile='' then outfile='images.htm'
if cols=''  then cols=5   /* default number of columns of images */

xx = stream(outfile,C,'query exists')
    if xx<>'' then do
    say 'Output file' outfile 'exists'
    say 'Press Enter to replace it; X to quit'
    yy=linein()
    if yy<>'' then exit
    xx=sysfiledelete(outfile)
    end


here=directory()

xx=stream(outfile,C,'open write')

header.0=6
header.1='<HTML>'
header.2='<HEAD>'
header.3='<TITLE>Images in' here '</TITLE></HEAD><BODY>'
header.4='<P><BIG><B>IMAGHTML.CMD' lev '(by Julian Thomas) did this.</B></BIG>'
header.5='<P><FONT SIZE="-2">Size is width * height</FONT><P>'
header.6="<TABLE BORDER='2' RULES='ALL'><TR>"
/* header.6="<TABLE BORDER='2' RULES='NONE'><TR>" */



'@dir /B *.gif *.jpg 2> NUL | RXQUEUE'
/*'@dir /B *.gif | RXQUEUE'  replaces previous line for GIF only */

if queued=0 then do
   say 'No files to process'
   exit
   end

j=1
do while queued()>0
    parse pull files.j .
    j=j+1
    end
files.0=j-1

do i=1 to header.0 
   xx= lineout(outfile, header.i)
   end


call putqueue

call lineout outfile, '</HTML>'

call lineout outfile

exit

putqueue: procedure expose outfile cols files.

i=0
do j=1 to files.0 by 1
   filenam = files.j
   parse upper var filenam . '.' ext
   size=stream(filenam,'C','QUERY SIZE')
   siz=''
   if ext='GIF' then do
        call gifsize
        if width>0 then siz=width||'x'||height
	end /* GIF file */
    else if ext='JPG' then do
       call jpgsize
       if width>0 then siz=width||'x'||height
       end

   outlin='<TD><IMG SRC="'
   outlin=outlin||filenam||'"'
   if siz \= '' then do
       outlin=outlin||' ALT="'||filenam||'" WIDTH='||width
       outlin=outlin 'HEIGHT='||height
       end 
   outlin=outlin||'><BR>' filenam '<BR>' siz '<BR>' size 'bytes</TD>'
   call lineout outfile, outlin
   i=i+1
   if i=cols then do
      call lineout outfile,'<TR>'
      i=0
      end  /* new table row */
   end  /* files loop */

call lineout outfile,'</TABLE>'
return

jpgsize: procedure expose filenam width height
/* JPGINFO.CMD */
/* JTdidit program to try to extract size of a JPG file */


width=''
height=''

xx=stream(filenam,'C','open read')
   if xx <> 'READY:' then do
      say "Can't open file" filenam
      return
      end

head=charin(filenam,,2)
if head<>'FFD8'X then do
   say filenam 'Not a JPG file'
   return 
   end

do while chars(filenam)>0
   xx=charin(filenam,,2)
   if (xx= "FFC0"X) | (xx="FFC1"X) then do
      /* we have what we hope is the data frame */
      junk=charin(filenam,,3) /* pass over length and precision */
      hhex=charin(filenam,,2)
      whex=charin(filenam,,2)
      height= c2d(hhex)
      width= c2d(whex)
      call stream filenam,'C','CLOSE'

      return
      end
   else do
      xy=charin(filenam,,2)  /* get length */
      length=c2d(xy)
      junk=charin(filenam,,length-2)  /* skip over it */
      end
  end
  say 'No image segment found in file' filenam
  return


gifsize: procedure expose filenam width height
/* GIFINFO.CMD */
/* JTdidit program to try to extract size of a GIF file */

head=charin(filenam,,3)
if head<>'GIF' then do
   say filenam 'Not a GIF file'
   exit 
   end

junk=charin(filenam,,3)  /* pass over 87a or 89a or whatever */

   x=charin(filenam,,1)
   y=charin(filenam,,1)
   width=c2d(y||x)

   x=charin(filenam,,1)
   y=charin(filenam,,1)
   height=c2d(y||x)

/*  say 'W' width 'H' height */

call stream filenam,'C','CLOSE'
return

